package com.tptj.demo.hg.cell.property.provider;

import com.fr.intelli.record.Focus;
import com.fr.json.JSONException;
import com.fr.json.JSONObject;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.report.cell.CellElement;
import com.fr.report.fun.CellPropertyProvider;
import com.fr.report.fun.impl.AbstractCellPropertyProvider;
import com.fr.stable.StringUtils;
import com.fr.stable.web.Repository;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-06-03
 **/
@EnableMetrics
public class Demo extends AbstractCellPropertyProvider {

    public static final String XML_TAG = "DemoProperty";
    private String key;

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    @Override
    public String xmlTag() {
        return XML_TAG;
    }

    @Override
    public void readXML(XMLableReader reader) {
        key = reader.getAttrAsString("key", StringUtils.EMPTY);
    }

    @Override
    public void writeXML(XMLPrintWriter writer) {
        writer.startTAG(XML_TAG).attr("key",key).end();
    }

    @Override
    public CellPropertyProvider clone() {
        Demo obj = (Demo) super.clone();
        obj.key = key;
        return obj;
    }

    @Override
    @Focus(id="com.tptj.demo.hg.cell.property.provider.v10",text = "cell property provider")
    public void mixinCellJson(JSONObject cellJson, Repository repository, CellElement cellElement) throws JSONException {
        cellJson.put("key", key);
    }
}
