package com.tptj.demo.hg.cell.property.provider;

import com.fr.design.gui.itextfield.UITextField;
import com.fr.grid.GridKeyListener;
import com.fr.grid.selection.CellSelection;
import com.fr.quickeditor.CellQuickEditor;
import com.fr.report.cell.DefaultTemplateCellElement;
import com.fr.stable.ColumnRow;
import com.fr.stable.StringUtils;

import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import java.awt.*;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-06-03
 **/
public class KeyEditor extends CellQuickEditor {
    private UITextField w_key;
    private boolean isEditing = false;

    private DocumentListener documentListener = new DocumentListener() {
        @Override
        public void insertUpdate(DocumentEvent e) {
            changeReportPaneCell(w_key.getText().trim());
        }

        @Override
        public void removeUpdate(DocumentEvent e) {
            changeReportPaneCell(w_key.getText().trim());
        }

        @Override
        public void changedUpdate(DocumentEvent e) {
            changeReportPaneCell(w_key.getText().trim());
        }

    };

    public void showText(String str) {
        // 正在编辑时不处理
        if (isEditing) {
            return;
        }
        w_key.getDocument().removeDocumentListener(documentListener);
        w_key.setText(str);
        w_key.getDocument().addDocumentListener(documentListener);
    }

    private void changeReportPaneCell(String tmpText) {
        isEditing = true;
        CellSelection cs1 = (CellSelection) tc.getSelection();
        ColumnRow columnRow = ColumnRow.valueOf(cs1.getColumn(), cs1.getRow());
        columnRowTextField.setText(columnRow.toString());
        cellElement = tc.getEditingElementCase().getTemplateCellElement(cs1.getColumn(), cs1.getRow());
        if (cellElement == null) {
            CellSelection cs = (CellSelection) tc.getSelection();
            cellElement = new DefaultTemplateCellElement(cs.getColumn(), cs.getRow());
            tc.getEditingElementCase().addCellElement(cellElement, false);
        }
        if (tmpText != null ) {
            Demo property = new Demo();
            property.setKey(tmpText);
            cellElement.addCellAttr(property);
        }
        fireTargetModified();
        w_key.requestFocus();
        isEditing = false;
    }

    @Override
    public JComponent createCenterBody() {
        JPanel panel = new JPanel( new BorderLayout() );
        w_key = new UITextField();
        w_key.addKeyListener(new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent e) {
                if (tc == null) {
                    return;
                }
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    GridKeyListener dispatchListener = new GridKeyListener(tc.getGrid());
                    dispatchListener.keyPressed(e);
                    dispatchListener.keyTyped(e);
                }
            }
            @Override
            public void keyReleased(KeyEvent e) {
                if (tc != null) {
                    if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                        return;
                    }
                    tc.getGrid().dispatchEvent(e);
                }
            }
        });
        panel.add(w_key, BorderLayout.CENTER);
        return panel;
    }

    @Override
    public boolean isScrollAll() {
        return false;
    }

    @Override
    public Object getComboBoxSelected() {
        return null;
    }

    @Override
    protected void refreshDetails() {
        String str;
        if ( null == cellElement ) {
            str = StringUtils.EMPTY;
        } else {
            Demo attr = cellElement.getCellAttr( Demo.XML_TAG );
            if ( null == attr ) {
                str = StringUtils.EMPTY;
            } else{
                str = attr.getKey();
            }
        }
        showText(str);
        w_key.setEditable(tc.isSelectedOneCell());
    }
}
